<?php
class W3_XooguDynamicShortcodes
{
    
    /**
     *
     *
     
     NOTE
     
     
     
     
     
     
     
     When testing, it always looks like it isn't working because W3TC sends not modified header when you refresh the page
     
     
     
     In W3TC settings go to Browser Cache, then HTML & XML settings, and enable and change
     expires / cache control header to prevent browser caching and Not Modified Since headers being returned
     
     
     
     
     
     
     ****
     ****
     ****/
    
    
    
    //@var array $aShortcodesOrig Holds the original shortcodes handlers that we are replacing with our dynamic shortcodes
    protected $aShortcodesOrig = array();
    //@var array $aShortcodes Holds the shortcodes to make dynamic
    protected $aShortcodes;

    public function run()
    {
        if (defined('DOING_AJAX') && DOING_AJAX) {
			return;
		}
		$this->aShortcodes = w3tc_get_extension_config('xoogu-dynamic-shortcodes-w3tc', 'shortcodes', null, array());
        if (defined('W3TC_DYNAMIC_SECURITY')) {
            add_action('wp_loaded', array($this, 'initPreCache'));
        }
    }
    
    /**
	 *Add the shortcodes to be processed on the page before it is cached
	 *We simply add shortcode handlers that change the shortcode tags to have the secret key
	 *as part of the shortcode name
	 */
	public function initPreCache()
	{
		foreach ($this->aShortcodes as $sShortcode) {
			//Check the shortcode tag exists (may not if a wp-admin ajax request)
			if (!empty($GLOBALS['shortcode_tags'][$sShortcode])) {
				//backup shortcode so that we can still access the handler when processing the initial generation of the page
				$this->aShortcodesOrig[$sShortcode] = $GLOBALS['shortcode_tags'][$sShortcode];
				//replace existing shortcode handler with our dynamic handler
				add_shortcode($sShortcode, array($this, 'preCacheShortcodeHandler'));
                //reassign original shortcode handler when page has been generated and cached
                add_action('wp_footer', array($this,'restoreShortcodeHandler'),99);
			}
		}
	}
    
    
    /**
     *Restores the original shortcode handler, for use when the mfunc block is eval'd to display page on initial cache generation
     *Should be hooked to run after initial do_shortcode has run (e.g. in wp_footer)
     */
    public function restoreShortcodeHandler()
    {
        if (!empty($this->aShortcodesOrig)) {
            foreach ($this->aShortcodesOrig as $sShortcode => $mHandler) {
                remove_shortcode($sShortcode);
                add_shortcode($sShortcode, $mHandler);
            }
        };
    }
	
	
	/**
	 *Shortcode handler run when generating the page cache
	 *Replaces shortcode with execution of shortcode handler eval'd by enclosing in mfunc tags
	 *@param array $aAttrs The attributes from the shortcode
	 *@param string $sContent The text content the shortcode wraps
	 *@param string $sShortcode The name of shortcode we are generating the dynamic fragment for
	 *@return string The mfunc block containing the code to eval
	 */
	public function preCacheShortcodeHandler($aAttrs, $sContent='', $sShortcode)
	{
		return '<!-- mfunc '.W3TC_DYNAMIC_SECURITY.' -->'.
        'if (!empty($GLOBALS["shortcode_tags"]['."'$sShortcode'])) {".
            'echo call_user_func( $GLOBALS["shortcode_tags"]['."'$sShortcode'], unserialize(stripslashes('".addslashes(serialize($aAttrs))."')), '".addslashes($sContent)."',  '$sShortcode' );".
		'}'.
        '<!-- /mfunc '.W3TC_DYNAMIC_SECURITY.' -->';
	}
}

$ext = new W3_XooguDynamicShortcodes();
$ext->run();
